;use TIMER0 
;          D7     D6     D5     D4    D3    D2    D1     D0
;TCCR0A: COM0A1 COM0A0 COM0B1 COM0B0  -     -    WGM01  WGM00
;           0      0      0      0    0     0      1      0 

;          D7     D6     D5     D4    D3    D2    D1     D0
;TCCR0B: A FC0A FC0B     -      -    WGM02  CS2   CS1   CS0
;           0     0      0      0      0     1     0     1 

.equ tim0_modeA = 0x02		;mode=CTC (clear on compare match) OC0A, OC0B disconnect
.equ tim0_modeB = 0x05		;clk/1024 (7812.5 Hz), 
.equ tim0_comp_value = 0xff ;f = 8MHz/(1024*256) = 30.5 Hz (32.8ms)

.equ LED_mask = 1 << 5	;LED on PORTB(5) 

.def timcnt = R3	;timer IT software counter
.def tmp	= R16
.def tmp1	= R17
.def timcnt0 = R18

.MACRO Timer0_Init ;modeA, modeB, compvalue
		ldi		tmp,@0		
		out		TCCR0A,tmp
		ldi		tmp,@1		
		out		TCCR0B,tmp
		ldi		tmp,@2		
		out		OCR0A,tmp		
		lds		tmp,TIMSK0		;extended I/O space!
		ori		tmp,1<<OCIE0A	;Timer0 OC IT enabled
		sts		TIMSK0,tmp		;extended I/O space!
.ENDMACRO

		.DSEG

memvar1:.BYTE 1		;definition of memory variable (not used)

		.CSEG
		jmp	start
				
		.ORG 	OC0Aaddr		;OC0A IT entry point
		jmp		SIG_OUTPUT_COMPARE0


SIG_OUTPUT_COMPARE0:
		push	tmp
		in		tmp,SREG
		push	tmp

		or		timcnt,timcnt	;set Z flag if timcnt = 0
		breq	ztimcnt
		dec		timcnt
		rjmp	exit_SIG_OUTPUT_COMPARE0

ztimcnt:mov		timcnt, timcnt0
		in		tmp,PORTB
		ldi		tmp1,LED_mask		
		eor		tmp,tmp1		;toggle LED
		out		PORTB,tmp

exit_SIG_OUTPUT_COMPARE0:
		pop		tmp
		out		SREG,tmp
		pop		tmp
		reti		

MAIN:
start:	ldi		tmp,low(RAMEND)
		out		SPL,tmp
		ldi		tmp, high(RAMEND)
		out 	SPH,tmp
		
		ldi		tmp1,LED_mask
		out		DDRB,tmp1		;set output PORTD(5)
		TIMER0_Init tim0_modeA,tim0_modeB ,tim0_comp_value		;macro to init timer0
		ldi		timcnt0,30		;set software counter to blink LED 30/30.5 Hz ~1Hz
		sei		

loop:	jmp		loop		


