//(C) Zoltan Benesoczky
// Sample program for Ultrasonic distance measurement with AVR and HC-SR4 UH sensor
//-----------------------------------------

#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include "proj_inc.h"
#define DisplayRefresh 1000


//-------------- Display ------------------

void DisplayResults(DistMeasResult result)
{
	if(Time0Done())		// the display must not refresh too frequently
	{
		LCD_write_str(" Distance meter ",line1);
		if(result.valid)
		{
			LCD_write_str_int(" cm",result.value,left,line2);			
		}
		else
		{
			LCD_write_str("No echo!", line2);
		}
		
		StartTime0(DisplayRefresh);
	}
}


int main(void)
{	
	DistMeasResult DistResultCpy;
	uint8_t brightness = 5;
	unsigned char KeyCode;
	#ifdef Simul_UHsens
	KeyInit();
	#endif
	UH_DistanceMeas_Init();
	LCD_init();
	LCD_light(brightness);

	StartTime0(DisplayRefresh);
	sei();

	do{
		DistResultCpy = UH_DistanceMeas(~RESET);
		DisplayResults(DistResultCpy);	

	#ifdef Simul_UHsens
		if(KeyPressed(&KeyCode))
		{
			switch(KeyCode)
			{
			case KBT2:
				if (SimPulse < 10)
				{
				 SimPulse++;
				}
				break;
			case KBT1:
				if (SimPulse > 0)
				{
					SimPulse--;
				}
				break;						
			}
		}
	#endif	
	
	}while(1);
}
