#include <avr/io.h>
#include <avr/interrupt.h>
#include "proj_inc.h"
#include "I2C_hlr.h"

int main()
{
// calculating I2C bit rate register TWBR for fscl = 400kHz
#define Fi2c (long)400000
//i2c prescaler = 1
#define i2cbr (unsigned char)((long)Fcpu/(2*Fi2c)-8)

#define Temp_refresh 500
#define StartTemperatureRefreshTime(t) StartTime0(t)	//#define MACRO_NAME(arg1, arg2, ...) [code to expand to]
#define TemRefreshTimeDone() Time0Done()

// degree character: 
#define degree_char 0xdf
char celsius_str[6];

double td;
//float tf;
//int ti;
//unsigned char tmp;

	TIMER0_Init();
	LCD_init();
	//tmp = i2cbr;  //check the calculated bit rate
	TWI_Init(i2cbr, PrescVal_1);
	EMC1001_Ini(Hz4);	// set refresh rate of temperature sensor
	celsius_str[0] = 'C';
	celsius_str[1] = degree_char;	
	celsius_str[2] = 0;		// end of string
	sei();
	
	LCD_write_str("   I2C sample   ", line1);
	unsigned char with = 5;
	LCD_write_str_pos(celsius_str, line2, with+1);
	StartTemperatureRefreshTime(Temp_refresh);
	do{
		if(TemRefreshTimeDone())
		{
			if(Temperature(&td))
			{
				//dtostrf(td,5,2,temp_str);			//convert double to fix point string
				//strcat(temp_str," C");
				//dtostre(td, temp_str,2,0);		// convert double to floating point string
				//ti = (int)td;				
				//sprintf(temp_str, "%d C", ti);	//can convert only integer!
				//LCD_write_str(temp_str,line2);
						
				LCD_write_double_pos(td, with, 2, line2, 0);		// write double (float) to LCD
			}
			StartTemperatureRefreshTime(Temp_refresh);
		}	
	}while(1);
}
